<script>
  import CesiumViewer from './components/CesiumViewer.svelte'
  import DeviceCard from './components/DeviceCard.svelte'
  import SatelliteCard from './components/SatelliteCard.svelte'
  import { onDestroy, onMount } from 'svelte'

  let devices = []
  let satellites = []
  let cesiumViewer

  onMount(async () => {
    fetchDeviceData()
    fetchSatelliteData()
    // Fetch data every 10 seconds
    const intervalId_device = setInterval(fetchDeviceData, 10000)
    const intervalId_satellite = setInterval(fetchSatelliteData, 10000)
  })

  onDestroy(() => {
    clearInterval(intervalId_device)
    clearInterval(intervalId_satellite)
  })

  async function fetchDeviceData() {
    try {
      const response = await fetch(
        process.env.API_BASE_URL + '/nodes',
      ).catch((error) => console.error('Error fetching device data: ', error))
      devices = await response.json()
      devices.forEach((device) => {
        cesiumViewer.updateDeviceLocation(device)
      })
    } catch (error) {
      console.error('Error updating device location: ', error)
    }
  }

  async function fetchSatelliteData() {
    try {
      const response = await fetch(
        process.env.API_BASE_URL + '/satellites',
      ).catch((error) =>
        console.error('Error fetching satellite data: ', error),
      )
      satellites = await response.json()
      satellites.forEach((satellite) => {
        cesiumViewer.updateSatelliteLocation(satellite)
      })
    } catch (error) {
      console.error('Error updating satellite location: ', error)
    }
  }

  function handleCardSelect(event) {
    const { latitude, longitude } = event.detail
    cesiumViewer.centerOnLocation(latitude, longitude)
  }

  function handleCardUnselect() {
    cesiumViewer.resetCamera()
  }
</script>

<style>
  .layout {
    display: flex;
    height: 100vh;
  }
  .cesium-viewer {
    flex: 3;
  }
  .sidebar {
    display: flex;
    flex: 1;
    flex-direction: column;
    height: 100%;
  }
  .sidebar h1 {
    text-align: center;
    color: #000;
  }
  .device-cards {
    flex-grow: 2;
    flex-shrink: 1;
    flex-basis: 50%; /* Adjust if you want a minimum height when empty */
    overflow-y: auto;
  }
  .device-cards h2 {
    position: sticky;
  }
  .satellite-list {
    flex-grow: 1;
    flex-shrink: 1;
    flex-basis: 50%; /* Sets the initial size to 1/2 of the sidebar */
    overflow-y: auto;
  }
  .satellite-list h2 {
    top: 0;
    z-index: 10;
    padding: 40px 0;
    background-color: #fff;
    position: sticky;
    text-align: center;
    color: #000;
  }
  .device-cards h2 {
    top: 0;
    z-index: 10;
    padding: 40px 0;
    background-color: #fff;
    position: sticky;
    text-align: center;
    margin: 10px 0;
    color: #000;
  }
</style>

<svelte:head>
  <title>GeoPi</title>
</svelte:head>

<div class="layout">
  <div class="sidebar">
    <h1>GeoPi</h1>
    <div class="device-cards">
      <h2>Connected Devices</h2>
      {#if devices.length > 0}
        {#each devices as device}
          <DeviceCard
            {device}
            on:select={handleCardSelect}
            on:unselect={handleCardUnselect} />
        {/each}
      {:else}
        <p>No devices connected</p>
      {/if}
    </div>
    <div class="satellite-list">
      <h2>Connected Satellites</h2>
      {#if satellites.length > 0}
        {#each satellites as satellite}
          <SatelliteCard {satellite} />
        {/each}
      {:else}
        <p>No satellites connected</p>
      {/if}
    </div>
  </div>
  <div class="cesium-viewer">
    <CesiumViewer bind:this={cesiumViewer} />
  </div>
</div>
